
import { IsIn,IsNumber,IsString,ValidateIf } from 'class-validator';

export class DataService {

  @IsString()
  className?: string;
  @IsString()
  filter?: string;
  @IsString()
  data?: string;

  // @Field()
  // dataObj?: any;

  @IsString()
  responseToID?: String;
  
  @IsString()
  requestID?: String;

  @IsNumber()
  returnSequenceNumber?: Number;

  @IsNumber()
  returnSequenceTotal?: Number;
  
  @ValidateIf(o => o.returnFormatType === '')
  @IsIn(['full','byBatchOf5','byBatchOf10','byRow'])
  returnFormatType?: string;



}
