import { Module } from '@nestjs/common';
import { ConfigModule } from '@nestjs/config';
import { FisAppQueryModule } from './FisAppQueryMicroserviceModule/fisAppQuery.module';
import { QueryClientModule } from './QueryClientProxy/queryClient.module';
import { ScheduleModule } from '@nestjs/schedule';
import { FisAppGraphQlapiController } from './FisAppGraphQLAPI/FisAppGraphQLAPI.controller';
import { HttpModule } from '@nestjs/axios';
import { ServiceProviderController } from './FisAppGraphQLAPI/ServiceProviderController';

@Module({
  imports: [ScheduleModule.forRoot(), ConfigModule.forRoot({ envFilePath: `${process.argv[2].split('=')[1]}` }), QueryClientModule, FisAppQueryModule, HttpModule],
  controllers: [FisAppGraphQlapiController, ServiceProviderController],
})
export class AppModule { }
